
<%@page import="com.ibm.rdm.fronting.server.threaddump.*"%>
<%@page import="java.util.*"%>
<%@page import="java.lang.*"%>
<%@page import="java.io.*"%>
<%@page import="java.lang.management.*"%>


<html>
  <head>
    <title>JVM Stack Traces</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/> 
    <style type="text/css">
      body {
        margin: 2px;
        background: #FFFFFF;
        color: #000000;
        font-family: Arial,sans-serif;
        font-size: 10pt;
      }
      
      table {
      	border-collapse:collapse;
      }
      
      table, th, td {
      	text-align:left;
      	border: 1px solid black;
      }
      
      td {
      	padding:5px;
      	font-size: 9pt;
      }
      
      a, a:link, a:visited {
      	text-decoration: none;
   	  }
        
	  a:hover, a:active {
      	font-weight: bold;
      	text-decoration:underline;
      }
      
    </style>
  </head>
  <%!
  	void printThreadInfo(TInfo threadInfo, JspWriter out) throws IOException {
  		out.println(threadInfo.name);
  		out.println(threadInfo.daemon ? "daemon" : "");
  		out.println(" priority="+threadInfo.priority );
  		out.println("<b>");
  		out.println( threadInfo.lockinfo != null ? " on " + threadInfo.lockinfo : "" );
  		out.println("</b>");
  		out.println("<br>");
  		out.println("java.lang.Thread.State: "+threadInfo.state.name());
  		out.println(threadInfo.suspended ? "(Suspended)" : "");
  		out.println(threadInfo.innative ? "(In Native)" : "" );
  		out.println("<br>");
  	}
  	void printStackElements(TInfo threadInfo, JspWriter out) throws IOException {
  		if (threadInfo.lockedSyncs.size()>0) {
  			printSyncInfo(threadInfo.lockedSyncs, out);
  		}
  		if ( threadInfo.lockedMons.size() > 0 ) {
  		    out.println("<b>Locked monitors count: "+threadInfo.lockedMons.size() +"</b><br>");
  		}
				   
  		for (StackTraceElement stackTraceElement : threadInfo.elements) {
			out.println(stackTraceElement.getClassName()+"."+stackTraceElement.getMethodName());
			out.println("<i>(");
			if (stackTraceElement.getLineNumber()==-1) {
				out.println("Unknown");
			} else if (stackTraceElement.getLineNumber()==-2) {
				out.println("Native");
			} else if (stackTraceElement.getLineNumber() < -2 ) {
				out.println("Unknown");
		    } else {
		        out.println(stackTraceElement.getFileName()+":"+stackTraceElement.getLineNumber());
		    }
		    out.println(")</i><br>");
			
			MonInfo mon = threadInfo.getMonInfo(stackTraceElement);
			if (mon!=null) {
				out.println("<b>  - locked "+mon+"</b><br>");
			}
		}
	}
	
  	void printSyncInfo(Collection<LInfo> locks, JspWriter out) throws IOException {
    	out.println( "<b>Locked synchronizers count: " + locks.size()+"</b><br>	");
	    for (LInfo li : locks) {
	       out.println("<b>  - " + li+"</b>");
	    }
	    out.println("<br>");
  	}
  	void printMonitorInfo(Collection<MonInfo> locks, JspWriter out) throws IOException {
    	out.println( "<b>Locked monitors count: " + locks.size()+"</b><br>");
	    for (LInfo li : locks) {
	      out.println("<b>  - " + li+"</b>");
	    }
	    out.println("<br>");
  	}
  %>
  <%
  		JMXInfo info = new JMXInfo();
		List<TInfo> snapshot = info.getStackTraces();
		
  %>
  <body>
  	<div><h2>JVM stack traces</h2></div>
  	<br/>
  	<div>
  		<% if (info.getDeadlocks().length>0) { %>
	  		<div style="padding-bottom: 30px;background-color: #FFFFE0; "><b>Deadlock found!</b><br><br>
	  		<% for (long id : info.getDeadlocks() ) { %>
	  			<div style="padding-bottom: 30px;padding-left: 30px">
	  				<% printThreadInfo( info.findTInfoById(snapshot, id),out );%>
	  				<div style="padding-left:30px"><% printStackElements(info.findTInfoById(snapshot, id), out); %> </div>
	  			</div>
	  		<% } %>
	  		</div>
  		<% } %>
  	
		<% for (TInfo threadInfo : snapshot) { %>
				<div style="padding-bottom: 30px">
				<% printThreadInfo(threadInfo,out); %>
				<div style="padding-left: 30px; background-color: #eeeeee;">	
				    
				    <% printStackElements(threadInfo, out); %> 
					
				</div>
			</div>
		<% } %>
	</div>
	
  </body>
</html>
