<%@page import="com.ibm.rdm.fronting.server.logging.internal.*"%>
<%@page import="com.ibm.rdm.fronting.server.services.logging.internal.*"%>
<%@page import="java.util.*"%>
<%@page import="org.apache.commons.lang.*"%>

<jsp:useBean id="logFeedInfo" scope="request" class="LogFeedInfo"/>
<jsp:useBean id="configUrl" scope="request" class="String"/>
<jsp:useBean id="jvmPropertiesUrl" scope="request" class="String"/>

<html>
  <head>
  <title>Server logs and JVM information</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/> 
    <style type="text/css">
      body {
        margin: 2px;
        background: #FFFFFF;
        color: #000000;
        font-family: Arial,sans-serif;
        font-size: 10pt;
      }
      
      table {
      	border-collapse:collapse;
      }
      
      table, th, td {
      	text-align:left;
      	border: 1px solid black;
      }
      
      td {
      	padding:5px;
      	font-size: 9pt;
      }
      
      a, a:link, a:visited {
      	text-decoration: none;
   	  }
        
	  a:hover, a:active {
      	font-weight: bold;
      	text-decoration:underline;
      }
      
    </style>
  </head>
  <body>
  	<div><h2>Server Logs</h2></div>
  	<div><a href='<%=configUrl%>'>Configure Loggers</a></div>
  	<br/>
  	<div>
	  	<table>
	  	<%
	  	 	Map<String, List<LogFileInfo>> map = logFeedInfo.getLogFilesByDir();
			for (String folderName : map.keySet()) {
				%>
				<tr>
					<th colspan="5">
						<%=folderName%>
					</th>
				</tr>
				<%
				List<LogFileInfo> filesInFolder = map.get(folderName);
				for (LogFileInfo file : filesInFolder) {
				%>
				<tr>
					<td>
						<%=file.getFile().getName()%>
					</td>
					<td>
						<%=file.getLastModified()%>
					</td>
					<td>
						<a href="<%=file.getAssociatedUrl()%>?private&format=textplain">Raw Log</a>
					</td>
					<td>
						<a href="<%=file.getAssociatedUrl()%>?private&format=textplain&stream=true">Raw Log (live stream)</a>
					</td>
					<td>
						<a href="<%=file.getAssociatedUrl()%>?private&format=html">HTML</a>
					</td>
				</tr>
				<%
				}
			}
		%>
		</table>
	</div>
	<div><h2>JVM</h2></div>
	<div><a href='<%=jvmPropertiesUrl%>?view=properties'>View JVM properties</a></div>
	<div><a href='<%=jvmPropertiesUrl%>?view=stacktraces'>View stacktraces for active threads</a></div>
	<% if (DumpUtil.isIBMVM()) { %>
		<hr>
		<div><p>See the <a href="http://www.ibm.com/developerworks/java/jdk/diagnosis/">IBM JVM diagnostic guides</a> for information on the following commands. </p></div>
		
		<div><a href='<%=jvmPropertiesUrl%>?dump=java'>Trigger IBM JVM JavaDump (.txt)</a> This is a small file, contains stack traces and detailed system information.</div>
		<div><a href='<%=jvmPropertiesUrl%>?dump=heap'>Trigger IBM JVM HeapDump (.phd)</a> This is a large file, contains entire process allocated memory. </div>
		<div><a href='<%=jvmPropertiesUrl%>?dump=system'>Trigger IBM JVM SystemDump (.dmp)</a> This is a very large file, also known as crash dump, it is the most detailed. Contains detailed information on all processes.</div>
	
		<br><div><b><i>Caution: running these commands is not recommended on a production system since they will stop server execution while the dumps are being created.</i></b></div>
 	<% } %>
  </body>
</html>
